#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* i commented these includes because i use DKA, just uncomment them if you dont use it*/

/*#include "gpfont.h"
#include "gpgraphic.h"
#include "gpmem.h"
#include "gpmm.h"
#include "gpos_def.h"
#include "gpsockdef.h"
#include "gpstdio.h"
#include "gpstdlib.h"*/
#include "gpsdk/gpsdk.h"
#include "defines.h"

#include "system.h"

/* for file requester */
#include "gpsdk/gpfilereq.h"

char * romfile = "gp:\\gpmm\\handygp\\lynxboot.img";
char * gamefile = "gp:\\gpmm\\handygp\\toki.lnx";
char * romdir = "gp:\\gpmm\\handygp";

GPDRAWSURFACE gpDraw[2];

unsigned short vram[2][160*102];

extern "C" {
  void write ( int ff, char * bla, int fd )
    {
    }
}

void loadFile(const char * fname, void * dest, int start, int size)
  {
    F_HANDLE fhandle;
    unsigned long tmp=0;
    
    if (GpFileOpen(fname, OPEN_R, &fhandle)!=SM_OK)
      {
        printf("Couldn't load file **1**\n");
        exit(1);
      }
    if (start>0)
      {
        GpFileSeek(fhandle, FROM_BEGIN, start, NULL);
      }
    GpFileRead(fhandle, dest, size, &tmp);
    GpFileClose(fhandle);
  }

/* Converts 8bit rgb values to a GP32 palette value */
#define GP_RGB24(r,g,b) (((((r>>3))&0x1f)<<11)|((((g>>3))&0x1f)<<6)|((((b>>3))&0x1f)<<1))

/* Sets a single GP32 palette entry */
void GpSetPaletteEntry ( u8 i, u8 r, u8 g, u8 b )
  {
    GP_PALETTEENTRY entry = GP_RGB24(r,g,b);
    GpPaletteEntryChange ( i, 1, &entry, 0 );
  }

void SetColors(void)
  {
    int i;
    for (i=0;i<256;i++)
      {
        GpSetPaletteEntry(i, (i&0x003)*(256/4), ((i*0x01c)>>2)*(256/8), ((i&0x0e0)>>5)*(256/8));
      }
  }

void lynxtimer ( void )
  {
    gTimerCount++;
  }

void GpMain ( void * args )
  {
    int ticks1;
    CSystem * newsystem;
    int surf = 0;
    FSEL handyfilereq;
    int waitkey=0;
	    
    handyfilereq.fname=gamefile;	/* Pointer to a buffer which will be filled with the selected file's name */
    handyfilereq.gpDraw=gpDraw;		/* Pointer to the GP32 surface which will be used for gfx output */
    
    /* i just picked random colors for the following, too lazy to pick nice ones*/
    handyfilereq.bgcolor=0;		/* Background color */
    handyfilereq.dircolor=24;		/* Directory entry color */
    handyfilereq.filecolor=58;		/* File entry color */
    handyfilereq.dirselcolor=100;	/* Selected directory entry color */
    handyfilereq.fileselcolor=200;	/* Selected file entry color */
    handyfilereq.curdircolor=255;	/* Color of current directory display at the top of the screen */    
  
    GpClockSpeedChange(132000000, 0x3a011, 3);

    GpGraphicModeSet(8, NULL);
    GpLcdSurfaceGet(&gpDraw[0], 0);
    GpLcdSurfaceGet(&gpDraw[1], 1);
    GpSurfaceSet(&gpDraw[0]);
    GpLcdEnable();
  
    GpFatInit();
    GpKeyInit();
    GpSurfaceFlip(&gpDraw[0]);
    GpTextOut(NULL, &gpDraw[0], 0,40, "             Handy GP v0.2", 0);
    GpTextOut(NULL, &gpDraw[0], 0,80, "   By CHN - http://chn.roarvgm.com/", 0);
    GpTextOut(NULL, &gpDraw[0], 0,92, "  Very Small Additions by Guyfawkes", 0);
    GpTextOut(NULL, &gpDraw[0], 0,104, "        http://www.gp32emu.com/", 0); 
    GpTextOut(NULL, &gpDraw[0], 0,200, "        Press START to continue", 0);

    while(waitkey==0)
    {
	if (GpKeyGet()&GPC_VK_START) waitkey=1;
    }

    GpRelativePathSet("gp:\\gpmm\\handygp");
    FileRequest ( &handyfilereq, romdir, 0 );
    
    GpGraphicModeSet(16, NULL);
	
    GpLcdSurfaceGet(&gpDraw[0], 0);
    GpLcdSurfaceGet(&gpDraw[1], 1);
    GpSurfaceSet(&gpDraw[0]);
    GpSurfaceFlip(&gpDraw[0]);
    GpTextOut16(NULL, &gpDraw[0], 100,110, "Loading Game...", 255);    
    SetColors ();

    newsystem = new CSystem(gamefile,HANDY_FILETYPE_LNX,romfile);
    newsystem->SetScreenAttributes(MIKIE_BITMAP_NORMAL_BPP16_X1, 160, 102, 0, 0, (UBYTE*)vram[0], (UBYTE*)vram[0]);

    GpTimerOptSet ( 1, 20, 0, lynxtimer );
    GpTimerSet ( 1 );

    ticks1=GpTickCountGet();
    
    while (!(GpKeyGet()&GPC_VK_START))
      {
        int i,j,d,s;
        ULONG k = GpKeyGet();

        for (i=0;i<1024;i++)
          newsystem->Update();

/*        if ((GpTickCountGet()-ticks1)>=50)
          {
            ticks1=GpTickCountGet();
            gTimerCount++;
          }*/
        newsystem->SetButtonData( k&GPC_VK_FA?BUTTON_A:0 |
                                  k&GPC_VK_FB?BUTTON_B:0 |
                                  k&GPC_VK_UP?BUTTON_UP:0 |
                                  k&GPC_VK_DOWN?BUTTON_DOWN:0 |
                                  k&GPC_VK_LEFT?BUTTON_LEFT:0 |
                                  k&GPC_VK_RIGHT?BUTTON_RIGHT:0 );

        if(gScreenUpdateRequired)
          {
            unsigned short * srcbuf;

            gFrameCount++;
            gScreenUpdateRequired=FALSE;
            
            if (newsystem->GetDisplayBuffer())
              {
                srcbuf = vram[0];
              } else
              {
                srcbuf = vram[0];
              }

            {
              int x,y;
              y=0;
            for (i=0,s=0,d=239;i<102*2;i++)
              {
                x=0;
                for (j=0;j<160*2;j++)
                  {
                    ((unsigned short*)gpDraw[surf&1].ptbuffer)[d] = srcbuf[(x>>1)+((101-(y>>1))*160)];
                    d+=240;
                    s++;
                    x++;
                  }
                y++;
                d-=240*(160*2);
                d-=1;
              }
            }

            GpSurfaceSet(&gpDraw[surf&1]);
            surf++;
          }
      }
    GpAppExit();
  }
